//*********************************************************
//        Falling Man  by  WinG
//*********************************************************
#include <acknex.h>

#define BOUNDARY_WIDTH	500		//boundary width
#define BOUNDARY_HEIGHT	800		//boundary height
#define BLOCK_SPACING	90		//distance between levels
#define BLOCK_TOTAL		10		//total number of blocks
#define PLAYER_SPEED	15		//player's movement speed
STRING* Gstr_gameover = "GAME OVER\n";
STRING* Gstr_SpaceHelp = ">>> Press [SPACE] to start the game! <<<";
typedef struct{ENTITY* entity;} AENTITY;
AENTITY Gblock_ent[BLOCK_TOTAL];	//blocks

var G_HP = 100;		//player's health points
var G_Level = 0;	//current level
STRING* Gstr_HP = "";
STRING* Gstr_LEVEL = "";
FONT* Gfont_arial_32b = "Arial#32b";
FONT* Gfont_arial_20b = "Arial#20b";
FONT* Gfont_arial_12 = "Arial#12";
TEXT* Gtext_Panel =	{
	layer = 2; pos_x = 5; pos_y = 5;
	font = Gfont_arial_20b; string(Gstr_HP,Gstr_LEVEL);
	red = 29; green = 98; blue = 175; flags = SHOW;
} 
TEXT* Gtext_Help = {
	layer = 1; pos_x = 5; pos_y = 50;
	font = Gfont_arial_12; string("ESC : Quit\n<- : Left Move\n-> : Right Move");
	red = 255; green = 255; blue = 255; flags = SHOW | OUTLINE;
}
TEXT* Gtext_Space = {
	layer = 3; pos_x = 0; pos_y = 0;
	font = Gfont_arial_32b; strings=1;
	red = 255; green = 255; blue = 255; flags = CENTER_X | CENTER_Y | SHOW | OUTLINE;
}
var G_tmp_before = 0, G_use_level = 0;
function func_random_arrangement_block( ENTITY* p, var i ) //blocks are generated automatically and arranged randomly
{
	p.x = 0;
	p.y = random(BOUNDARY_WIDTH)-BOUNDARY_WIDTH/2;
	if( abs(p.x - G_tmp_before) < 30 ) {
		if( (p.x + G_tmp_before) > BOUNDARY_WIDTH ) p.x -= G_tmp_before;
		else p.x += G_tmp_before;
		G_tmp_before = p.x;
	}
	if( i == -1 ) {
		p.z = 0;
		p.skill2 = G_use_level;
		G_use_level++;
	}
	else {
		p.z = i * BLOCK_SPACING;
		if( p.z > BOUNDARY_HEIGHT ) p.skill100 = 1;
		else {
			p.skill2 = G_use_level;
			G_use_level++;
		}
	}
}
action act_block()
{
	reset(my,INVISIBLE); //
	//my.skill1   : 0 stop, 1 run
	//my.skill2   : the level of current block
	//my.skill100 : 0 normal, 1 elimate the unused blocks
	while(1)
	{
		if( my.skill100 == 1 )
			set(my,INVISIBLE); //set it invisible
		else
		if( my.skill1 ) {
			my.z += 3 * time_step; //block's movement speed
			if( my.z < 0 || my.z > BOUNDARY_HEIGHT ) func_random_arrangement_block( my, -1 ); //±߽
		}
		wait(1);
	}
}
action act_player()
{
	player = me;
	random_seed(0);
	var i, tmp_before = 0;
	for(i=0; i<BLOCK_TOTAL; i++) {
		Gblock_ent[i].entity = ent_create("mgunammo.mdl",nullvector,act_block);
		func_random_arrangement_block( Gblock_ent[i].entity, i );
	}
	var percentage_run, percentage_stand, tmp_level_length;
	BOOL tmp_subHP_state, tmp_state;
	ENTITY* tmp_subHP_block;
	while(1)
	{	//initialization
		G_HP = 100;
		G_Level = 0;
		tmp_level_length = 0;
		tmp_subHP_state = FALSE;
		tmp_subHP_block = NULL;
		G_use_level = 0;
		for(i=4; i>=0; i--) { //assign the skills to the blocks, starting with the fifth block
			Gblock_ent[i].entity.skill2 = G_use_level;
			G_use_level++;
		}
		vec_set(my.x,Gblock_ent[4].entity.x); //put player on the fifty block defaultly
		reset(my,INVISIBLE);
		while(!key_space) wait(1);//wait till the [SPACE] is pressed
		reset(Gtext_Space,SHOW);
		for(i=0; i<BLOCK_TOTAL; i++) Gblock_ent[i].entity.skill1 = 1;//start to move blocks
		while(G_HP > 0)
		{
			if( key_cul || key_cur ) {
				ent_animate(my, "run", percentage_run, ANM_CYCLE);
				percentage_run += PLAYER_SPEED * time_step * 0.8;
				if( key_cul ) {
					my.pan = 270;
					my.y -= PLAYER_SPEED * time_step;
				}
				if( key_cur ) {
					my.pan = 90;
					my.y += PLAYER_SPEED * time_step;
				}
			}
			else {
				my.pan = 0;
				ent_animate(my, "stand", percentage_stand, ANM_CYCLE);
				percentage_stand += PLAYER_SPEED * time_step * 0.4;
			}
			//gravity on the z-axis
			if( my.z < 0 ) G_HP = 0; //GAME OVER
			else {
				tmp_state = FALSE;
				if( my.z < 620 ) {
					for(i=0; i<BLOCK_TOTAL; i++) {
						if(Gblock_ent[i].entity.skill100 == 0 ) {
							if(abs(my.z-Gblock_ent[i].entity.z)<=10 && my.y>(Gblock_ent[i].entity.y-90) && my.y<(Gblock_ent[i].entity.y+90)) {
								my.z = Gblock_ent[i].entity.z;
								if( tmp_subHP_block != Gblock_ent[i].entity ) {
									G_Level = Gblock_ent[i].entity.skill2; 
									tmp_subHP_block = Gblock_ent[i].entity;
									tmp_subHP_state = TRUE;
								}
								break;
							}
						}
					}
				}
				else
				if( tmp_subHP_state ) {
					G_HP -= 10; //damage on player's health points
					tmp_subHP_state = FALSE;
				}
				if( !tmp_state ) my.z -= PLAYER_SPEED * time_step;
			}
			wait(1);
		}
		//GAME OVER : Play the game again?
		set(my,INVISIBLE); //Hide the player
		for(i=0; i<BLOCK_TOTAL; i++) {
			Gblock_ent[i].entity.skill1 = 0; 
			Gblock_ent[i].entity.skill2 = 0; //clean blocks' skills
		}
		str_cpy(( Gtext_Space.pstring )[0],Gstr_gameover);
		str_cat(( Gtext_Space.pstring )[0],Gstr_SpaceHelp);
		set(Gtext_Space,SHOW);
		while(!key_space) wait(1); 
		//rearrange blocks
		for(i=0; i<BLOCK_TOTAL; i++) func_random_arrangement_block( Gblock_ent[i].entity, i );  
	}
}
function main()
{
	video_mode = 7;
	fps_max = 60;
	d3d_antialias = 4;
	Gtext_Space.pos_x = screen_size.x/2;
	Gtext_Space.pos_y = screen_size.y/2;
	str_cpy(( Gtext_Space.pstring )[0],Gstr_SpaceHelp);
	level_load(NULL);
	ENTITY* tmp_sky_ent = ent_createlayer("skycube+6.tga", SKY | CUBE | SHOW,1);
	ent_create("player.mdl",vector(0,0,400),act_player);
	vec_set(sun_color,vector(200,240,240));	
	vec_set(camera.x,vector(523,-65,613));
	vec_set(camera.pan,vector(172,-19,0));
	camera.arc = 75;
	STRING* tmpStr = str_create("");
	while(1)
	{
		if (key_esc) break;
		str_cpy(Gstr_HP,"HP : ");
		str_for_num(tmpStr, G_HP);
		str_cat(Gstr_HP,tmpStr);
		str_cpy(Gstr_LEVEL,"LEVEL : ");
		str_for_num(tmpStr, G_Level);
		str_cat(Gstr_LEVEL,tmpStr);
		if( is(Gtext_Space,SHOW) ) Gtext_Space.blue += 30*time_step;
		wait(1);
	}
	sys_exit(NULL);
}